import { _decorator, Component, Node } from 'cc';
import { uiManager } from '../../manager/uiManager';
import { home_car } from './home_car';
import { home_top } from './home_top';
import { home_bottom } from './home_bottom';
import { tools } from '../../tools';
import { ClientEvent } from '../../lib/clientEvent';
import { config } from '../../config';
import { userDataManager } from '../../manager/userDataManager';
import { user_results } from '../../data';
import { GameManager } from '../../GameManager';
const { ccclass, property } = _decorator;

@ccclass('home')
export class home extends Component {
    @property(Node) home_car:Node = null
    @property(Node) top:Node = null
    @property(Node) bottom:Node = null
    @property(Node) btn_start_game:Node = null

    protected start(): void {
        uiManager.Instance().onButtonListen(this.btn_start_game,()=>{
            GameManager.checkPlayGame(this.node,()=>{
                tools.playGame(()=>{
                    this.node.parent.active = true
                })
                this.node.parent.active = false
            })
        })
        ClientEvent.on(config.UI_EVENT.GET_NEW_CAR,this.onGetNewCar.bind(this),this)
        ClientEvent.on(config.UI_EVENT.UPDATE_USER_DEFAULT_CAR,this.onUpdateUserDefaultCar.bind(this),this)
        ClientEvent.on(config.UI_EVENT.GAME_OVER_SETTLE_ACCOUNT,this.onGameOverSettleAccount.bind(this),this)
        ClientEvent.on(config.EVENT_TYPE.MSG_GUANGBO_RANK,this.onMsgGuangboRank.bind(this),this)
    }

    onGameOverSettleAccount(res:user_results){
        // 更新本周分数、荣誉
        tools.mine_rank_data.score = res.max_integral
        this.bottom.getComponent(home_bottom).reloadWeekScore()
        tools.mine_rank_data.city_badge_status = res.city_badge_status
        tools.mine_rank_data.province_badge_status = res.province_badge_status
        tools.mine_rank_data.nationwide_badge_status = res.nationwide_badge_status
        this.bottom.getComponent(home_bottom).reloadHonorData()
    }

    onGetNewCar(res:user_results){
        // 更新默认车
        userDataManager.user_car_list.default_car_id = res.default_car_id
        // console.log("获取新车:",dataManager.getCarInfoById(userDataManager.user_car_list.default_car_id))
        // 更新用户解锁车列表
        userDataManager.user_car_list.car_list = res.unlock_car_list
        // 更新首页车
        this.home_car.getComponent(home_car).updateCar()
    }

    onUpdateUserDefaultCar() {
        this.home_car.getComponent(home_car).updateCar()
    }

    onMsgGuangboRank(msg) {
        this.top.getComponent(home_top).reloadGuangboData(msg.notice_list)
        this.bottom.getComponent(home_bottom).reloadCountryRankData(msg.ranking_list)
        if(msg.ranking_list.length>0) {
            for (let index = 0; index < msg.ranking_list.length; index++) {
                const element = msg.ranking_list[index]
                if(element.user_id==userDataManager.user_data.id) {
                    tools.mine_rank_data.nationwide_badge_status = 1
                    this.bottom.getComponent(home_bottom).reloadHonorData()
                    break
                }
                
            }
        }
    }

    public init(){
        this.top.getComponent(home_top).init()
        this.home_car.getComponent(home_car).updateCar()
        this.bottom.getComponent(home_bottom).init()
    }
}


